Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

cam = CreateCamera()
PositionEntity cam,0,10,-20

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()



Repeat

If KeyHit(57) Then CreateBunch(0,20,0)
If KeyHit(42) Then FreeAllJoints()


pxRenderPhysic(60,0)
UpdatepxCubes()

RenderWorld()
Flip

Until KeyHit(1)
End

Type pxCube
	Field mesh
	Field body
End Type

Type Joint
	Field Joint
End Type

Function FreeAllJoints()
	For j.Joint = Each Joint
		pxDeleteJoint(J\Joint)
		Delete J
	Next
End Function

Function UpdatepxCubes()
	For pxC.pxCube = Each pxCube
		pxBodySetEntity pxC\mesh, pxC\body
	Next
End Function

Function CreateBunch(x#,y#,z#)
	Cube1.pxCube = CreatepxCube(x#,y#+5,z#)
	Cube2.pxCube = CreatepxCube(x#,y#-5,z#)		
	Joint = pxJointCreateSpherical (Cube1\Body,Cube2\Body,x,y,z,0,1,0)
	pxJointSphericalSetLimitAngle(Joint, 30,1, 0)
	pxJointSphericalSetLimitTwist(Joint,-10,10,10,1,0)
	pxJointSphericalSetLimitSpring(Joint, 10, 1, 0)
	J.Joint = New Joint
	J\Joint = Joint
End Function



Function CreatepxCube.pxCube(x#,y#,z#)
	pxC.pxCube = New pxCube
	pxC\mesh = CreateCube()
	ScaleEntity pxC\mesh,1,5,1
	pxC\body = pxBodyCreateCube(1,5,1,1)
	pxBodySetPosition pxC\body,x,y,z
	Return pxC
End Function